diff --git a/base/server/src/engine/pkihelper.py b/base/server/src/engine/pkihelper.py
index df36583079cea16a0d199de3e0007bc7a1a12e12..5c43e9d91fad1d5f316cf97e5f8e7cb1f398c4fe 100644
--- a/base/server/src/engine/pkihelper.py
+++ b/base/server/src/engine/pkihelper.py
@@ -129,9 +129,11 @@ def pki_copytree(src, dst, symlinks = False, ignore = None):
     if errors:
         raise Error, errors
 
-# PKI Deployment Identity Class
-class identity:
-    def __add_gid(self, pki_group):
+class Identity:
+    "PKI Deployment Identity Class"
+    @staticmethod
+    def __add_gid(pki_group):
+        "Adding a group id"
         pki_gid = None
         try:
             # Does the specified 'pki_group' exist?
@@ -181,7 +183,9 @@ class identity:
             raise
         return
 
-    def __add_uid(self, pki_user, pki_group):
+    @staticmethod
+    def __add_uid(pki_user, pki_group):
+        "Add the User Id"
         pki_uid = None
         try:
             # Does the specified 'pki_user' exist?
@@ -255,13 +259,17 @@ class identity:
                                  extra = config.PKI_INDENTATION_LEVEL_2)
             raise
         return
-
-    def add_uid_and_gid(self, pki_user, pki_group):
-        self.__add_gid(pki_group)
-        self.__add_uid(pki_user, pki_group)
+    
+    @staticmethod
+    def add_uid_and_gid(pki_user, pki_group):
+        "Add both User ID and Group ID"
+        Identity.__add_gid(pki_group)
+        Identity.__add_uid(pki_user, pki_group)
         return
 
-    def get_uid(self, critical_failure = True):
+    @staticmethod
+    def get_uid(critical_failure = True):
+        "Fetch the user id."
         try:
             pki_uid = master['pki_uid']
         except KeyError as exc:
@@ -271,7 +279,9 @@ class identity:
                 raise
         return pki_uid
 
-    def get_gid(self, critical_failure = True):
+    @staticmethod
+    def get_gid(critical_failure = True):
+        "Fetch the group id."
         try:
             pki_gid = master['pki_gid']
         except KeyError as exc:
@@ -281,7 +291,9 @@ class identity:
                 raise
         return pki_gid
 
-    def set_uid(self, name, critical_failure = True):
+    @staticmethod
+    def set_uid(name, critical_failure = True):
+        "Modify the user id."
         try:
             config.pki_log.debug(log.PKIHELPER_USER_1, name,
                                  extra = config.PKI_INDENTATION_LEVEL_2)
@@ -297,7 +309,9 @@ class identity:
                 raise
         return pki_uid
 
-    def set_gid(self, name, critical_failure = True):
+    @staticmethod
+    def set_gid(name, critical_failure = True):
+        "Modify the group id."
         try:
             config.pki_log.debug(log.PKIHELPER_GROUP_1, name,
                                  extra = config.PKI_INDENTATION_LEVEL_2)
@@ -314,11 +328,13 @@ class identity:
         return pki_gid
 
 
-# PKI Deployment Namespace Class
-class namespace:
-    # Silently verify that the selected 'pki_instance_name' will
-    # NOT produce any namespace collisions
-    def collision_detection(self):
+class Namespace:
+    "PKI Deployment Namespace Class"
+
+    @staticmethod
+    def collision_detection():
+        "Verify that the selected 'pki_instance_name' will not produce"\
+        " any namespace collisions"
         # Run simple checks for pre-existing namespace collisions
         if os.path.exists(master['pki_instance_path']):
             if os.path.exists(master['pki_subsystem_path']):
@@ -433,8 +449,11 @@ class namespace:
 
 
 # PKI Deployment Configuration File Class
-class configuration_file:
-    def log_configuration_url(self):
+class Configuration_file:
+    """PKI Deployment Configuration File Class"""
+    
+    @staticmethod
+    def log_configuration_url():
         # NOTE:  This is the one and only parameter containing a sensitive
         #        parameter that may be stored in a log file.
         config.pki_log.info(log.PKI_CONFIGURATION_WIZARD_URL_1,
@@ -444,7 +463,8 @@ class configuration_file:
                             master['pki_registry_initscript_command'],
                             extra = config.PKI_INDENTATION_LEVEL_2)
 
-    def display_configuration_url(self):
+    @staticmethod
+    def display_configuration_url():
         # NOTE:  This is the one and only parameter containing a sensitive
         #        parameter that may be displayed to the screen.
         print log.PKI_CONFIGURATION_URL_1 % master['pki_configuration_url']
@@ -453,7 +473,8 @@ class configuration_file:
               master['pki_registry_initscript_command']
         print
 
-    def verify_sensitive_data(self):
+    @staticmethod
+    def verify_sensitive_data():
         # Silently verify the existence of 'sensitive' data
         if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
             # Verify existence of Directory Server Password (ALWAYS)
@@ -546,7 +567,8 @@ class configuration_file:
                                                                                          master['pki_user_deployment_cfg']))
         return
 
-    def verify_mutually_exclusive_data(self):
+    @staticmethod
+    def verify_mutually_exclusive_data():
         # Silently verify the existence of 'mutually exclusive' data
         if master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
             if master['pki_subsystem'] == "CA":
@@ -580,7 +602,8 @@ class configuration_file:
                         extra = config.PKI_INDENTATION_LEVEL_2)
                     raise Exception(log.PKIHELPER_MUTUALLY_EXCLUSIVE_EXTERNAL_SUB_CA % master['pki_user_deployment_cfg'])
 
-    def verify_predefined_configuration_file_data(self):
+    @staticmethod
+    def verify_predefined_configuration_file_data():
         # Silently verify the existence of any required 'predefined' data
         #
         # FUTURE:  As much as is possible, alter this routine to verify
@@ -781,7 +804,8 @@ class configuration_file:
                         raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % "pki_extrenal_ca_cert_path")
         return
 
-    def populate_non_default_ports(self):
+    @staticmethod
+    def populate_non_default_ports():
         if master['pki_http_port'] != \
             str(config.PKI_DEPLOYMENT_DEFAULT_TOMCAT_HTTP_PORT):
                 ports.append(master['pki_http_port'])
@@ -796,7 +820,8 @@ class configuration_file:
                 ports.append(master['pki_ajp_port'])
         return
 
-    def verify_selinux_ports(self):
+    @staticmethod
+    def verify_selinux_ports():
         # Determine which ports still need to be labelled, and if any are
         # incorrectly labelled
         if len(ports) == 0:
@@ -816,7 +841,7 @@ class configuration_file:
                 if portrecs[i][0] == "unreserved_port_t" or \
                    portrecs[i][0] == "reserved_port_t" or \
                    i[2] != "tcp":
-                       continue
+                    continue
                 if i[0] <= int(port) and int(port) <= i[1]:
                     context = portrecs[i][0]
                     break
@@ -836,7 +861,8 @@ class configuration_file:
                 raise Exception(log.PKIHELPER_INVALID_SELINUX_CONTEXT_FOR_PORT % (port, context))
         return
 
-    def verify_command_matches_configuration_file(self):
+    @staticmethod
+    def verify_command_matches_configuration_file():
         # Silently verify that the command-line parameters match the values
         # that are present in the corresponding configuration file
         if master['pki_deployment_executable'] == 'pkidestroy':
@@ -887,8 +913,11 @@ class configuration_file:
 
 
 # PKI Deployment Instance Class
-class instance:
-    def apache_instance_subsystems(self):
+class Instance:
+    """ PKI Deployment Instance Class """
+    
+    @staticmethod
+    def apache_instance_subsystems():
         rv = 0
         try:
             # count number of PKI subsystems present
@@ -905,8 +934,9 @@ class instance:
                                  extra = config.PKI_INDENTATION_LEVEL_2)
             raise
         return rv
-
-    def apache_instances(self):
+    
+    @staticmethod
+    def apache_instances():
         rv = 0
         try:
             # Since ALL directories under the top-level PKI 'apache' registry
@@ -933,7 +963,8 @@ class instance:
             raise
         return rv
 
-    def pki_instance_subsystems(self):
+    @staticmethod
+    def pki_instance_subsystems():
         rv = 0
         try:
             # Since ALL directories within the top-level PKI infrastructure
@@ -961,7 +992,8 @@ class instance:
             raise
         return rv
 
-    def tomcat_instance_subsystems(self):
+    @staticmethod
+    def tomcat_instance_subsystems():
         # Return list of PKI subsystems in the specified tomcat instance
         rv = []
         try:
@@ -974,8 +1006,9 @@ class instance:
                                  extra = config.PKI_INDENTATION_LEVEL_2)
             raise
         return rv
-
-    def tomcat_instances(self):
+ 
+    @staticmethod
+    def tomcat_instances():
         rv = 0
         try:
             # Since ALL directories under the top-level PKI 'tomcat' registry
@@ -1002,7 +1035,8 @@ class instance:
             raise
         return rv
 
-    def verify_subsystem_exists(self):
+    @staticmethod
+    def verify_subsystem_exists():
         try:
             if not os.path.exists(master['pki_subsystem_path']):
                 config.pki_log.error(log.PKI_SUBSYSTEM_DOES_NOT_EXIST_2,
@@ -1016,7 +1050,8 @@ class instance:
                                  extra = config.PKI_INDENTATION_LEVEL_2)
             raise
 
-    def verify_subsystem_does_not_exist(self):
+    @staticmethod
+    def verify_subsystem_does_not_exist():
         try:
             if os.path.exists(master['pki_subsystem_path']):
                 config.pki_log.error(log.PKI_SUBSYSTEM_ALREADY_EXISTS_2,
@@ -1030,8 +1065,9 @@ class instance:
                                  extra = config.PKI_INDENTATION_LEVEL_2)
             raise
 
-    def get_instance_status(self):
-        self.connection = pki.client.PKIConnection(
+    @staticmethod
+    def get_instance_status():
+        connection = pki.client.PKIConnection(
             protocol = 'https',
             hostname = master['pki_hostname'],
             port = master['pki_https_port'],
@@ -1039,7 +1075,7 @@ class instance:
             accept = 'application/xml')
 
         try:
-            client = pki.system.SystemStatusClient(self.connection)
+            client = pki.system.SystemStatusClient(connection)
             response = client.getStatus()
             config.pki_log.debug(response,
                 extra = config.PKI_INDENTATION_LEVEL_3)
@@ -1052,20 +1088,23 @@ class instance:
                 extra = config.PKI_INDENTATION_LEVEL_3)
             return None
 
-    def wait_for_startup(self, timeout):
+    @staticmethod
+    def wait_for_startup(timeout):
         start_time = datetime.today()
         status = None
         while status != "running":
-            status = self.get_instance_status()
+            status = Instance.get_instance_status()
             time.sleep(1);
             stop_time = datetime.today()
             if (stop_time - start_time).total_seconds() >= timeout:
                 break
         return status
 
-# PKI Deployment Directory Class
-class directory:
-    def create(self, name, uid = None, gid = None,
+class Directory:
+    """PKI Deployment Directory Class"""
+
+    @staticmethod    
+    def create(name, uid = None, gid = None,
                perms = config.PKI_DEPLOYMENT_DEFAULT_DIR_PERMISSIONS,
                acls = None, critical_failure = True):
         try:
@@ -1080,9 +1119,9 @@ class directory:
                 os.chmod(name, perms)
                 # chown <uid>:<gid> <name>
                 if uid == None:
-                    uid = identity.get_uid()
+                    uid = Identity.get_uid()
                 if gid == None:
-                    gid = identity.get_gid()
+                    gid = Identity.get_gid()
                 config.pki_log.debug(log.PKIHELPER_CHOWN_3,
                                      uid, gid, name,
                                      extra = config.PKI_INDENTATION_LEVEL_3)
@@ -1114,7 +1153,8 @@ class directory:
                     raise
         return
 
-    def modify(self, name, uid = None, gid = None,
+    @staticmethod
+    def modify(name, uid = None, gid = None,
                perms = config.PKI_DEPLOYMENT_DEFAULT_DIR_PERMISSIONS,
                acls = None, silent = False, critical_failure = True):
         try:
@@ -1136,9 +1176,9 @@ class directory:
                 os.chmod(name, perms)
                 # chown <uid>:<gid> <name>
                 if uid == None:
-                    uid = identity.get_uid()
+                    uid = Identity.get_uid()
                 if gid == None:
-                    gid = identity.get_gid()
+                    gid = Identity.get_gid()
                 if not silent:
                     config.pki_log.debug(log.PKIHELPER_CHOWN_3,
                                          uid, gid, name,
@@ -1161,7 +1201,7 @@ class directory:
                     log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1, name,
                     extra = config.PKI_INDENTATION_LEVEL_2)
                 if critical_failure == True:
-                    raise Exception(log.PKI_DIRECTORY_NISSING_OR_NOT_A_DIRECTORY_1 % name)
+                    raise Exception(log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1 % name)
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
                                  extra = config.PKI_INDENTATION_LEVEL_2)
@@ -1169,7 +1209,8 @@ class directory:
                 raise
         return
 
-    def delete(self, name, recursive_flag = True, critical_failure = True):
+    @staticmethod
+    def delete(name, recursive_flag = True, critical_failure = True):
         try:
             if not os.path.exists(name) or not os.path.isdir(name):
                 # Simply issue a warning and continue
@@ -1194,7 +1235,8 @@ class directory:
                 raise
         return
 
-    def exists(self, name):
+    @staticmethod
+    def exists(name):
         try:
             if not os.path.exists(name) or not os.path.isdir(name):
                 return False
@@ -1204,8 +1246,8 @@ class directory:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
                                  extra = config.PKI_INDENTATION_LEVEL_2)
             raise
-
-    def is_empty(self, name):
+    @staticmethod
+    def is_empty(name):
         try:
             if not os.listdir(name):
                 config.pki_log.debug(log.PKIHELPER_DIRECTORY_IS_EMPTY_1,
@@ -1219,8 +1261,8 @@ class directory:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
                                  extra = config.PKI_INDENTATION_LEVEL_2)
             raise
-
-    def set_mode(self, name, uid = None, gid = None,
+    @staticmethod
+    def set_mode(name, uid = None, gid = None,
                  dir_perms = config.PKI_DEPLOYMENT_DEFAULT_DIR_PERMISSIONS,
                  file_perms = config.PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS,
                  symlink_perms = \
@@ -1238,9 +1280,9 @@ class directory:
                     log.PKIHELPER_SET_MODE_1, name,
                     extra = config.PKI_INDENTATION_LEVEL_2)
                 if uid == None:
-                    uid = identity.get_uid()
+                    uid = Identity.get_uid()
                 if gid == None:
-                    gid = identity.get_gid()
+                    gid = Identity.get_gid()
                 if recursive_flag == True:
                     for root, dirs, files in os.walk(name):
                         for name in files:
@@ -1355,7 +1397,8 @@ class directory:
             if critical_failure == True:
                 raise
 
-    def copy(self, old_name, new_name, uid = None, gid = None,
+    @staticmethod
+    def copy(old_name, new_name, uid = None, gid = None,
              dir_perms = config.PKI_DEPLOYMENT_DEFAULT_DIR_PERMISSIONS,
              file_perms = config.PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS,
              symlink_perms = config.PKI_DEPLOYMENT_DEFAULT_SYMLINK_PERMISSIONS,
@@ -1395,11 +1438,11 @@ class directory:
                     shutil.copy2(old_name, new_name)
                 # set ownerships, permissions, and acls
                 # of newly created top-level directory
-                self.modify(new_name, uid, gid, dir_perms, dir_acls,
+                Directory.modify(new_name, uid, gid, dir_perms, dir_acls,
                             True, critical_failure)
                 # set ownerships, permissions, and acls
                 # of contents of newly created top-level directory
-                self.set_mode(new_name, uid, gid,
+                Directory.set_mode(new_name, uid, gid,
                               dir_perms, file_perms, symlink_perms,
                               dir_acls, file_acls, symlink_acls,
                               recursive_flag, critical_failure)
@@ -1416,9 +1459,10 @@ class directory:
         return
 
 
-# PKI Deployment File Class (also used for executables)
-class file:
-    def create(self, name, uid = None, gid = None,
+class File:
+    """PKI Deployment File Class (also used for executables)"""
+    @staticmethod
+    def create(name, uid = None, gid = None,
                perms = config.PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS,
                acls = None, critical_failure = True):
         try:
@@ -1433,9 +1477,9 @@ class file:
                 os.chmod(name, perms)
                 # chown <uid>:<gid> <name>
                 if uid == None:
-                    uid = identity.get_uid()
+                    uid = Identity.get_uid()
                 if gid == None:
-                    gid = identity.get_gid()
+                    gid = Identity.get_gid()
                 config.pki_log.debug(log.PKIHELPER_CHOWN_3,
                                      uid, gid, name,
                                      extra = config.PKI_INDENTATION_LEVEL_3)
@@ -1467,7 +1511,8 @@ class file:
                     raise
         return
 
-    def modify(self, name, uid = None, gid = None,
+    @staticmethod
+    def modify(name, uid = None, gid = None,
                perms = config.PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS,
                acls = None, silent = False, critical_failure = True):
         try:
@@ -1489,9 +1534,9 @@ class file:
                 os.chmod(name, perms)
                 # chown <uid>:<gid> <name>
                 if uid == None:
-                    uid = identity.get_uid()
+                    uid = Identity.get_uid()
                 if gid == None:
-                    gid = identity.get_gid()
+                    gid = Identity.get_gid()
                 if not silent:
                     config.pki_log.debug(log.PKIHELPER_CHOWN_3,
                                          uid, gid, name,
@@ -1522,7 +1567,8 @@ class file:
                 raise
         return
 
-    def delete(self, name, critical_failure = True):
+    @staticmethod
+    def delete(name, critical_failure = True):
         try:
             if not os.path.exists(name) or not os.path.isfile(name):
                 # Simply issue a warning and continue
@@ -1541,7 +1587,8 @@ class file:
                 raise
         return
 
-    def exists(self, name):
+    @staticmethod
+    def exists(name):
         try:
             if not os.path.exists(name) or not os.path.isfile(name):
                 return False
@@ -1552,7 +1599,8 @@ class file:
                                  extra = config.PKI_INDENTATION_LEVEL_2)
             raise
 
-    def copy(self, old_name, new_name, uid = None, gid = None,
+    @staticmethod
+    def copy(old_name, new_name, uid = None, gid = None,
              perms = config.PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS, acls = None,
              overwrite_flag = False, critical_failure = True):
         try:
@@ -1574,9 +1622,9 @@ class file:
                                     extra = config.PKI_INDENTATION_LEVEL_2)
                 shutil.copy2(old_name, new_name)
                 if uid == None:
-                    uid = identity.get_uid()
+                    uid = Identity.get_uid()
                 if gid == None:
-                    gid = identity.get_gid()
+                    gid = Identity.get_gid()
                 # chmod <perms> <new_name>
                 config.pki_log.debug(log.PKIHELPER_CHMOD_2,
                                      perms, new_name,
@@ -1610,8 +1658,9 @@ class file:
                 raise
         return
 
+    @staticmethod
     def apply_slot_substitution(
-                         self, name, uid = None, gid = None,
+                         name, uid = None, gid = None,
                          perms = config.PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS,
                          acls = None, critical_failure = True):
         try:
@@ -1634,9 +1683,9 @@ class file:
                         line = line.replace(slots[slot], master[slot])
                 sys.stdout.write(line)
             if uid == None:
-                uid = identity.get_uid()
+                uid = Identity.get_uid()
             if gid == None:
-                gid = identity.get_gid()
+                gid = Identity.get_gid()
             # chmod <perms> <name>
             config.pki_log.debug(log.PKIHELPER_CHMOD_2,
                                  perms, name,
@@ -1670,8 +1719,9 @@ class file:
                 raise
         return
 
+    @staticmethod
     def copy_with_slot_substitution(
-                         self, old_name, new_name, uid = None, gid = None,
+                         old_name, new_name, uid = None, gid = None,
                          perms = config.PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS,
                          acls = None, overwrite_flag = False,
                          critical_failure = True):
@@ -1704,9 +1754,9 @@ class file:
                     FILE.write(line)
                 FILE.close()
                 if uid == None:
-                    uid = identity.get_uid()
+                    uid = Identity.get_uid()
                 if gid == None:
-                    gid = identity.get_gid()
+                    gid = Identity.get_gid()
                 # chmod <perms> <new_name>
                 config.pki_log.debug(log.PKIHELPER_CHMOD_2,
                                      perms, new_name,
@@ -1740,7 +1790,8 @@ class file:
                 raise
         return
 
-    def generate_noise_file(self, name, bytes, uid = None, gid = None,
+    @staticmethod
+    def generate_noise_file(name, bytes, uid = None, gid = None,
             perms = config.PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS,
             acls = None, critical_failure = True):
         try:
@@ -1761,9 +1812,9 @@ class file:
                 os.chmod(name, perms)
                 # chown <uid>:<gid> <name>
                 if uid == None:
-                    uid = identity.get_uid()
+                    uid = Identity.get_uid()
                 if gid == None:
-                    gid = identity.get_gid()
+                    gid = Identity.get_gid()
                 config.pki_log.debug(log.PKIHELPER_CHOWN_3,
                                      uid, gid, name,
                                      extra = config.PKI_INDENTATION_LEVEL_3)
@@ -1784,7 +1835,7 @@ class file:
                     log.PKI_FILE_ALREADY_EXISTS_NOT_A_FILE_1, name,
                     extra = config.PKI_INDENTATION_LEVEL_2)
                 if critical_failure == True:
-                    raise Exception(log.PKI_FILE_ALREADY_EXISTS_MOT_A_FILE_1 % name)
+                    raise Exception(log.PKI_FILE_ALREADY_EXISTS_NOT_A_FILE_1 % name)
         except OSError as exc:
             if exc.errno == errno.EEXIST:
                 pass
@@ -1796,9 +1847,11 @@ class file:
         return
 
 
-# PKI Deployment Symbolic Link Class
-class symlink:
-    def create(self, name, link, uid = None, gid = None,
+class Symlink:
+    """PKI Deployment Symbolic Link Class"""
+    
+    @staticmethod
+    def create(name, link, uid = None, gid = None,
                acls = None, allow_dangling_symlink = False, critical_failure = True):
         try:
             if not os.path.exists(link):
@@ -1817,9 +1870,9 @@ class symlink:
                 #            CANNOT be run directly against symbolic links!
                 # chown -h <uid>:<gid> <link>
                 if uid == None:
-                    uid = identity.get_uid()
+                    uid = Identity.get_uid()
                 if gid == None:
-                    gid = identity.get_gid()
+                    gid = Identity.get_gid()
                 config.pki_log.debug(log.PKIHELPER_CHOWN_H_3,
                                      uid, gid, link,
                                      extra = config.PKI_INDENTATION_LEVEL_3)
@@ -1851,8 +1904,9 @@ class symlink:
                 if critical_failure == True:
                     raise
         return
-
-    def modify(self, link, uid = None, gid = None,
+ 
+    @staticmethod
+    def modify(link, uid = None, gid = None,
                acls = None, silent = False, critical_failure = True):
         try:
             if os.path.exists(link):
@@ -1871,9 +1925,9 @@ class symlink:
                 #            CANNOT be run directly against symbolic links!
                 # chown -h <uid>:<gid> <link>
                 if uid == None:
-                    uid = identity.get_uid()
+                    uid = Identity.get_uid()
                 if gid == None:
-                    gid = identity.get_gid()
+                    gid = Identity.get_gid()
                 if not silent:
                     config.pki_log.debug(log.PKIHELPER_CHOWN_H_3,
                                          uid, gid, link,
@@ -1905,7 +1959,8 @@ class symlink:
                 raise
         return
 
-    def delete(self, link, critical_failure = True):
+    @staticmethod
+    def delete(link, critical_failure = True):
         try:
             if not os.path.exists(link) or not os.path.islink(link):
                 # Simply issue a warning and continue
@@ -1924,7 +1979,8 @@ class symlink:
                 raise
         return
 
-    def exists(self, name):
+    @staticmethod
+    def exists(name):
         try:
             if not os.path.exists(name) or not os.path.islink(name):
                 return False
@@ -1935,9 +1991,11 @@ class symlink:
                                  extra = config.PKI_INDENTATION_LEVEL_2)
             raise
 
-# PKI Deployment War File Class
-class war:
-    def explode(self, name, path, critical_failure = True):
+class War:
+    """PKI Deployment War File Class"""
+    
+    @staticmethod
+    def explode(name, path, critical_failure = True):
         try:
             if os.path.exists(name) and os.path.isfile(name):
                 if not zipfile.is_zipfile(name):
@@ -1983,9 +2041,11 @@ class war:
         return
 
 
-# PKI Deployment Password Class
-class password:
-    def create_password_conf(self, path, pin, pin_sans_token = False,
+class Password:
+    """PKI Deployment Password Class"""
+
+    @staticmethod
+    def create_password_conf(path, pin, pin_sans_token = False,
                              overwrite_flag = False, critical_failure = True):
         try:
             if os.path.exists(path):
@@ -2004,7 +2064,6 @@ class password:
                         else:
                             fd.write(master['pki_self_signed_token'] + \
                                      "=" + str(pin))
-                    fd.closed
             else:
                 config.pki_log.info(log.PKIHELPER_PASSWORD_CONF_1, path,
                                     extra = config.PKI_INDENTATION_LEVEL_2)
@@ -2019,7 +2078,6 @@ class password:
                     else:
                         fd.write(master['pki_self_signed_token'] + \
                                  "=" + str(pin))
-                fd.closed
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
                                  extra = config.PKI_INDENTATION_LEVEL_2)
@@ -2027,7 +2085,8 @@ class password:
                 raise
         return
 
-    def create_client_pkcs12_password_conf(self, path, overwrite_flag = False,
+    @staticmethod
+    def create_client_pkcs12_password_conf(path, overwrite_flag = False,
                                            critical_failure = True):
         try:
             if os.path.exists(path):
@@ -2038,14 +2097,12 @@ class password:
                     # overwrite the existing 'pkcs12_password.conf' file
                     with open(path, "wt") as fd:
                         fd.write(master['pki_client_pkcs12_password'])
-                    fd.closed
             else:
                 config.pki_log.info(log.PKIHELPER_PASSWORD_CONF_1, path,
                                     extra = config.PKI_INDENTATION_LEVEL_2)
                 # create a new 'pkcs12_password.conf' file
                 with open(path, "wt") as fd:
                     fd.write(master['pki_client_pkcs12_password'])
-                fd.closed
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
                                  extra = config.PKI_INDENTATION_LEVEL_2)
@@ -2053,7 +2110,8 @@ class password:
                 raise
         return
 
-    def get_password(self, path, token_name, critical_failure = True):
+    @staticmethod
+    def get_password(path, token_name, critical_failure = True):
         if os.path.exists(path) and os.path.isfile(path) and\
            os.access(path, os.R_OK):
             tokens = PKIConfigParser.read_simple_configuration_file(path)
@@ -2062,7 +2120,7 @@ class password:
                 token_name = hardware_token
                 token_pwd = tokens[hardware_token]
             elif tokens.has_key(token_name):
-                   token_pwd = tokens[token_name]
+                token_pwd = tokens[token_name]
 
         if token_pwd is None or token_pwd == '':
             # TODO prompt for this password
@@ -2076,9 +2134,11 @@ class password:
         return token_pwd
 
 
-# PKI Deployment NSS 'certutil' Class
-class certutil:
-    def create_security_databases(self, path, pki_cert_database,
+class Certutil:
+    """PKI Deployment NSS 'certutil' Class"""
+    
+    @staticmethod
+    def create_security_databases(path, pki_cert_database,
                                   pki_key_database, pki_secmod_database,
                                   password_file = None, prefix = None,
                                   critical_failure = True):
@@ -2140,10 +2200,11 @@ class certutil:
                 raise
         return
 
-    def verify_certificate_exists(self, path, pki_cert_database,
+    @staticmethod
+    def verify_certificate_exists(path, pki_cert_database,
                                   pki_key_database, pki_secmod_database,
                                   token, nickname, password_file = None,
-                                  silent = True):
+                                  silent = True, critical_failure = True):
         rv = 0
         try:
             # Compose this "certutil" command
@@ -2214,7 +2275,8 @@ class certutil:
                 raise
         return True
 
-    def generate_self_signed_certificate(self, path, pki_cert_database,
+    @staticmethod
+    def generate_self_signed_certificate(path, pki_cert_database,
                                          pki_key_database, pki_secmod_database,
                                          token, nickname,
                                          subject, serial_number,
